VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TREClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*****************************************
' TRE ARCHIVER VISUAL BASIC 6 SOURCE CODE
'        CREATED IN DECEMBER 2003
'          BY MIKE W. ZUURMAN
'         ALSO KNOWN AS MR.MOUSE
'      XENTAX http://www.xentax.com
'-----------------------------------------
'TREOBJECT.CLASS
'-----------------------------------------
'This class represents a *.TRE Archive
'TRE Archives are shipped with the PC game
'Star Wars : Galaxies, and contain the
'resources of the game, such as sounds,
'textures and game settings. Contact the producer
'of the game before you alter their game and ask
'for permission!
'Resources in TRE Archives may be compressed
'using NORMAL Zlib compression. Thus, using
'the "create" funtion you can create archives of
'your own, as an alternative to PKZip.
'THE TRECLASS REQUIRES THE DYNAMIC LIBRARY
'
' ZLIB.DLL (at least version 1.1.2.0)
' -----------------------------------
'
' available at http://www.zlib.net
'The TREClass Code is not very optimized
'and comments may be scarce.
'As long as you credit the author, you can
'do with it as you please, there are no
'copyrights on this file.
'*****************************************
' TRE Object Class
' Requires Zlib.dll
'*****************************************

Option Explicit

'****************************************
'public alterable things

Public Filename As String ' filename of TRE File
Public ErrorState As Integer ' Latest Error number
Public ErrorDescription As String ' Latest Error description
Public Status As Double ' Status of a process in % of completion
Public StatusDescription As String ' The description of the current process
Public ReplaceNames As Byte ' Binary, sets the Replace_Names_In_Tail function on/off
Public ReplaceOld As Byte ' Binary, sets Overwrite_Old_TRE_File on/off

'****************************************
'private things : types

Private Type TREItemInfo ' Information about the items in the TRE Archive
Item_Name As String 'The name of the item
Item_Unknown As Long ' The "unknown" variable in the Tail_Info list
Item_Size As Long ' The (compressed) size of the item
Item_Offset As Long ' THe offset of the item in the TRE Archive
Item_CompressionMethod As Long ' the compression method used on the item (2 = normal zlib, 0 = none)
Item_OriginalSize As Long ' the (original) size of the item
Item_FilenamePosInTail As Long 'the position of the filename string in the Filenames_Tail
Item_ReplaceTarget As Boolean ' whether the item is targeted for replacement
Item_ReplacerPath As String ' and if so, the path of the file to replace the item with

End Type

Private Type OffsetTrack ' keeps track of the offset of the items in the TRE Archive, but sorts them ascendingly
Offset As Long 'the offset of the item with index :
Index As Long ' the index of the item in the actual TRE Archive
End Type

Private Type TREHeaderInfo ' The TRE Archive ERT5000 Header
strID As String * 8 'the ID string -> "EERT5000" or ERT6000
Item_Num As Long ' the number of items in the archive
Tail_Start As Long ' the pointer to the Tail_Info tail in the TRE Archive
Com_Method_Tail_Info As Long 'the compression method used on the Tail_Info
Com_Size_Tail_Info As Long ' The (compressed) size of the Tail_Info
Com_Method_Tail_Filenames As Long 'The compression method used on the Tail_Filenames
Com_Size_Tail_Filenames As Long ' the (compressed) size of the Tail_Filenames
Original_Size_Tail_Filenames As Long 'the (original) size of the Tail_FIlenames
End Type

Private Type TOCResInfo
Resourcename As String
TREFile As Integer 'the tre file this resource is archived in (first file in the TRE filename list is file 0)
ComMethod As Integer 'compression used (0 = none, 2 = zlib)
Unknown As Long 'unknown pointer , this increments consistently
ResNameSize As Long ' size of the resource name - alternated between actual size and size including null, oddly enough
Offset As Long 'offset of the resource in the TRE file
OriginalSize As Long 'uncompressed size of the resource
ComSize As Long 'compressed size of the resource
End Type

Private Type TREFileToc
Filename As String
Exists As Boolean
LocalPath As String
ResNum As Long
ITable() As TOCResInfo
End Type

Private Type TRETOCInfo 'The TRE Table Of Contents file (" COT1000")
strID As String * 8
Reserved As Long
Res_Num As Long 'total number of files
ITableSize As Long 'size of Itable
FTableSize As Long  'size of filename list table
FTableSize2 As Long  'size of filename list table (again)
TRE_Num As Long 'number of tre files listed
TTableSize As Long 'Size of tre filename list
TTable() As TREFileToc 'tre file list
End Type


'****************************************
'private declarations

Private TRETOC As TRETOCInfo
Private TREHeader As TREHeaderInfo
Private TREItemList() As TREItemInfo
Private OffsetList() As OffsetTrack
Private Item_Num As Long ' the number of items in the TRE Archive
Private TREHeaderSize As Long ' the size in bytes of the TRE HEader (always 36)
Private strDebugLog As String ' the path of the (optional) debuglog
Private CurFormat As Byte '0 = nothing, 1 = tre, 2 =toc
Public curTOCTRE As Long
'****************************************
'private buffers
Private Tail_Info_Data() As Byte 'for accessing/writing the tail
Private Tail_Filenames_Data() As Byte 'for accessing/writing the tail

'****************************************
'zlib stuff

'Default Property Values:
Const m_def_CompressedSize = 0
Const m_def_OriginalSize = 0
'Property Variables:
Dim m_CompressedSize As Long
Dim m_OriginalSize As Long
Dim OriginalSize
Dim CompressedSize

Dim result

'****************************************
'External (ZLIB.DLL) Declarations
Private Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hwnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function compress Lib "zlib.dll" (dest As Any, destLen As Any, src As Any, ByVal srcLen As Long) As Long
Private Declare Function uncompress Lib "zlib.dll" (dest As Any, destLen As Any, src As Any, ByVal srcLen As Long) As Long

'****************************************
'CLASS PROPERTIES
'****************************************

Property Let DebugLog(strLog As String)
'****************************************
'If this is set, only THEN the log will be
'kept, so you can use it to turn ON the loggin
strDebugLog = strLog
If strDebugLog <> "" Then
DebugEntry "*** XENTAX TRECLASS New Debug Log *** > " & CStr(Date) & " " & CStr(Time)
End If

End Property

Property Let SetReplaceNames(repnames As Byte)
'****************************************
'Turn on(>0)/Off(0) the replacing of filenames
'in the filenamestail
 ReplaceNames = repnames
End Property

Property Let SetReplaceOld(repold As Byte)
'****************************************
'overwrite the old TRE Archive if
'-chosen the same savename as the old one
 ReplaceOld = repold
End Property


Property Get ProgressStatus() As Double
'****************************************
'Get the current status of any process
 ProgressStatus = Status
End Property



Property Get TOCTRECount() As Long
'****************************************
'Get the number of TRE files in the TOC
   TOCTRECount = TRETOC.TRE_Num
End Property


Property Get TOCTREExist(Num As Long) As Boolean
'****************************************
'Tell if a TRE file in the list was found
   TOCTREExist = TRETOC.TTable(Num).Exists
End Property

Property Let TOCSetTREPath(i As String)
Dim D() As String
D = Split(i, "|")

TRETOC.TTable(CLng(D(0))).LocalPath = D(1)
TRETOC.TTable(CLng(D(0))).Exists = True
End Property

Property Let TOCSetCurTRE(Num As Long)
curTOCTRE = Num
End Property

Property Get TOCTREName(Num As Long) As String
TOCTREName = TRETOC.TTable(Num).Filename
End Property

Property Get TOCTREItemCount(Num As Long) As Long
TOCTREItemCount = TRETOC.TTable(Num).ResNum
End Property
Property Get TOCTREItemName(TRENum As Long, Num As Long) As String
TOCTREItemName = TRETOC.TTable(TRENum).ITable(Num).Resourcename

End Property
Property Get TOCTREItemComSize(TRENum As Long, Num As Long) As Long
TOCTREItemComSize = TRETOC.TTable(TRENum).ITable(Num).ComSize

End Property
Property Get TOCTREItemOffset(TRENum As Long, Num As Long) As Long
TOCTREItemOffset = TRETOC.TTable(TRENum).ITable(Num).Offset

End Property

Property Get TOCTREItemUncomSize(TRENum As Long, Num As Long) As Long
TOCTREItemUncomSize = TRETOC.TTable(TRENum).ITable(Num).OriginalSize

End Property
Property Get TOCTREItemCom(TRENum As Long, Num As Long) As Integer
TOCTREItemCom = TRETOC.TTable(TRENum).ITable(Num).ComMethod

End Property

Property Get ItemCount() As Long
'****************************************
'Get the number of items in the TRE Archive
   ItemCount = Item_Num
End Property

Property Get ItemSize(Index As Long) As Long
'****************************************
'Get the size of the item with index Index
'in the TRE Archive
If Index < Item_Num Then
ItemSize = TREItemList(Index).Item_Size
Else
Error_Report (1)
End If

End Property

Property Get ItemOffset(Index As Long) As Long
'****************************************
'Get the offset of the item with index Index
'in the TRE Archive
If Index < Item_Num Then
ItemOffset = TREItemList(Index).Item_Offset
Else
Error_Report (1)
End If
End Property

Property Get ItemFilename(Index As Long) As String
'****************************************
'Get the filename of the item with index Index
'in the TRE Archive
If Index < Item_Num Then
ItemFilename = TREItemList(Index).Item_Name
Else
Error_Report (1)
End If
End Property

Property Get ItemCompressionMethod(Index As Long) As Long
'****************************************
'Get the compressionmethod of the item with index Index
'in the TRE Archive
If Index < Item_Num Then
ItemCompressionMethod = TREItemList(Index).Item_CompressionMethod
Else
Error_Report (1)
End If
End Property

Property Get ItemOriginalSize(Index As Long) As Long
'****************************************
'Get the originalsize of the item with index Index
'in the TRE Archive
If Index < Item_Num Then
ItemOriginalSize = TREItemList(Index).Item_OriginalSize
Else
Error_Report (1)
End If
End Property

'****************************************
'****************************************
'PUBLIC FUNCTIONS AND SUBS
'****************************************
'****************************************
Private Function FileExists(name As String) As Boolean
On Error GoTo Hell
Dim ff
ff = FreeFile
Open name For Binary Access Read As ff
Close ff
FileExists = True
Exit Function
Hell:
FileExists = False

End Function

Public Function OpenTOC(source As String) As Boolean

Dim f
f = FreeFile
StatusDescription = "Loading Table Of Contents file"
DoEvents
On Error GoTo Hell
With TRETOC
Open source For Binary Access Read As f
Get f, , .strID
If TRETOC.strID <> " COT1000" Then
Error_Report (9)
Close (f)
Exit Function
End If
Get f, , .Reserved
Get f, , .Res_Num
Get f, , .ITableSize
Get f, , .FTableSize
Get f, , .FTableSize2
Get f, , .TRE_Num
Get f, , .TTableSize

ReDim .TTable(.TRE_Num - 1)
Dim t
For t = 0 To .TRE_Num - 1
.TTable(t).Filename = ReadString(CByte(f), 0)
.TTable(t).Exists = MexFileExists(MexGetParentFolderName(source) & "\" & .TTable(t).Filename)
.TTable(t).LocalPath = MexGetParentFolderName(source) & "/" & .TTable(t).Filename
Next t
Dim tres As Integer
Dim ComM As Integer
Dim fpos As Long
Dim flpos  As Long
flpos = Seek(f)
flpos = flpos + (&H18 * .Res_Num)

For t = 0 To .Res_Num - 1
If .Res_Num > 1 Then Status = CDbl(t) / CDbl(.Res_Num - 1)
DoEvents
Get f, , ComM
Get f, , tres
ReDim Preserve .TTable(tres).ITable(.TTable(tres).ResNum)
.TTable(tres).ITable(.TTable(tres).ResNum).TREFile = tres
.TTable(tres).ITable(.TTable(tres).ResNum).ComMethod = ComM
Get f, , .TTable(tres).ITable(.TTable(tres).ResNum).Unknown
Get f, , .TTable(tres).ITable(.TTable(tres).ResNum).ResNameSize
Get f, , .TTable(tres).ITable(.TTable(tres).ResNum).Offset
Get f, , .TTable(tres).ITable(.TTable(tres).ResNum).OriginalSize
Get f, , .TTable(tres).ITable(.TTable(tres).ResNum).ComSize

fpos = Seek(f)
Seek f, flpos
.TTable(tres).ITable(.TTable(tres).ResNum).Resourcename = ReadString(CByte(f), 0)

flpos = Seek(f)
Seek f, fpos
.TTable(tres).ResNum = .TTable(tres).ResNum + 1


Next t
OpenTOC = True
End With
CurFormat = 2
Exit Function
Hell:
On Error Resume Next

Close (f)
Error_Report (1)
DebugEntry Err.Description
OpenTOC = False
End Function



Public Function Extract(AsBuffer As Byte, ByRef TheData() As Byte, Optional strPath As String, Optional strName As String = "MWZ!", Optional Index As Long = 559568717, Optional TRENum As Long) As Long
'****************************************
'Extracts a specified item to the path provided
'
'AsBuffer : Do(>0)/Do not(0) save, but return the (extracted) item as a buffer
'TheData() : will contain the extracted file if AsBuffer > 0
'strPath : the path to save the item to (optional)
'strName : the name of the item (optional)
'Index : the index of the item in the TRE Archive (optional)
'
'Note : strName OR Index must be given to identify
'the item in the list
Dim res
Dim strExtractPath As String
Dim statusstring As String

StatusDescription = "Extract->"
'if asbuffer than copy contents in Data()
'else use the strName tosave it
If strName = "MWZ!" And Index = 559568717 Then
Error_Report (8)
Extract = 8
Exit Function
End If

If AsBuffer = 0 Then
If strPath = "" Then strPath = App.path
Select Case CurFormat
Case 1: strExtractPath = strPath & "\" & MakePath(strPath, TREItemList(Index).Item_Name)
Case 2: strExtractPath = strPath & "\" & MakePath(strPath, TRETOC.TTable(TRENum).ITable(Index).Resourcename)
End Select
End If
'extract

Dim f, g
If AsBuffer = 0 Then
Dim TBuf() As Byte
f = FreeFile
Open strExtractPath For Binary Access Write As f
End If
Select Case CurFormat
Case 1: DoEvents
        If TREItemList(Index).Item_CompressionMethod = 2 Then
        ReDim TBuf(TREItemList(Index).Item_Size - 1)
        Else
        ReDim TBuf(TREItemList(Index).Item_OriginalSize - 1)
        End If
        g = FreeFile
        Open Filename For Binary Access Read As g
        Seek g, TREItemList(Index).Item_Offset + 1
        Get g, , TBuf
        Close g
        res = 0
        StatusDescription = statusstring & "Item Compression Method: " & TREItemList(Index).Item_CompressionMethod
        '------------------------
        DebugEntry StatusDescription
        '------------------------
        If TREItemList(Index).Item_CompressionMethod = 2 Then
        StatusDescription = statusstring & "Decompression of " & TREItemList(Index).Item_Name
        '------------------------
        DebugEntry StatusDescription
        '------------------------
        res = DecompressData(TBuf, TREItemList(Index).Item_OriginalSize)
        End If

Case 2: DoEvents
        If TRETOC.TTable(TRENum).ITable(Index).ComMethod = 2 Then
        ReDim TBuf(TRETOC.TTable(TRENum).ITable(Index).ComSize - 1)
        Else
        ReDim TBuf(TRETOC.TTable(TRENum).ITable(Index).OriginalSize - 1)
        End If
        g = FreeFile
        Open TRETOC.TTable(TRENum).LocalPath For Binary Access Read As g
        Seek g, TRETOC.TTable(TRENum).ITable(Index).Offset + 1
        Get g, , TBuf
        Close g
        res = 0
        StatusDescription = statusstring & "Item Compression Method: " & TRETOC.TTable(TRENum).ITable(Index).ComMethod
        '------------------------
        DebugEntry StatusDescription
        '------------------------
        If TRETOC.TTable(TRENum).ITable(Index).ComMethod = 2 Then
        StatusDescription = statusstring & "Decompression of " & TRETOC.TTable(TRENum).ITable(Index).Resourcename
        '------------------------
        DebugEntry StatusDescription
        '------------------------
        res = DecompressData(TBuf, TRETOC.TTable(TRENum).ITable(Index).OriginalSize)
        End If

End Select

If res = 0 Then
If AsBuffer Then
ReDim TheData(UBound(TBuf))

CopyMemory TheData(0), TBuf(0), UBound(TBuf) + 1
Else
Put f, , TBuf
Close f
End If
Error_Report (0)
Extract = 0

Else
Close f
Kill strExtractPath
Error_Report (9)
Extract = 9
End If

Erase TBuf



End Function


Public Function Replace(Activate As Byte, Optional strReplacePath As String, Optional SaveTREPath As String, Optional strName As String = "MWZ!", Optional Index As Long = 559568717) As Long
'****************************************
'Targets an item for replacement in the TRE Archive
'Depending on the Activate variable
'actual Replacement and creation of a new
'TRE Archive will follow
'
'Syntax:
'Activate : Target(0) the item and follow with (1) actual replacement
'strReplacePath : (optional) The path to the file that should replace the item in the TRE Archive
'strSaveTREPath : (Optional) The path that should become the new TRE Archive after replacement
'strName : (optional) the name of the item in the TRE Archive
'Index : (optional) the index of the item in the TRE Archive
'
'Note : strName OR Index must be given to identify
'the item in the list

Dim statusstring As String
statusstring = "Replace>"

'---------------------
DebugEntry statusstring & "Started"
'---------------------

If strName = "MWZ!" And Index = 559568717 Then
Error_Report (10)
Replace = 10
'---------------------
DebugEntry statusstring & ErrorDescription
'---------------------

Exit Function
End If

'if no index was given get it from the name
If Index = 559568717 Then
Dim c
For c = 0 To Item_Num
If strName = TREItemList(c).Item_Name Then
Index = c
c = Item_Num + 1
End If
Next c
End If
'if still no index (due to wrong name)
If Index = 559568717 Then
Error_Report (11)
Replace = 11
'---------------------
DebugEntry statusstring & ErrorDescription
'---------------------
Exit Function
End If

If Activate = 0 Then
'just target it
TREItemList(Index).Item_ReplacerPath = strReplacePath
TREItemList(Index).Item_ReplaceTarget = True
Replace = 0
'---------------------
DebugEntry statusstring & "Targeted: " & TREItemList(Index).Item_Name & " -> " & strReplacePath
'---------------------
Else
TREItemList(Index).Item_ReplacerPath = strReplacePath
TREItemList(Index).Item_ReplaceTarget = True
'---------------------
DebugEntry statusstring & "Targeted (and activate): " & TREItemList(Index).Item_Name & " -> " & strReplacePath
'---------------------
Replace = ReplaceCurrentTargets(SaveTREPath)
End If


End Function
Private Function ReadString(f2 As Byte, Optional size As Integer) As String
Dim TString As String
Dim ctr As Integer
Dim TByte As Byte
Dim limit As Integer

Dim NullT As Boolean
If size = 0 Then
limit = 255
NullT = True
Else
NullT = False
limit = size
If size > 255 Then limit = 255
End If

      TString = "": ctr = 0
      While ctr < limit
              Get f2, , TByte
              If TByte = 0 And NullT = True Then
              ctr = limit
              Else
               TString = TString & Chr(TByte)
               ctr = ctr + 1
               If ctr = limit Then
               Error_Report (7)
               ReadString = "____ERROR"
               'Close f1: Close f2
               ''Clear
               Exit Function
               End If
               
              End If
            Wend
ReadString = TString
End Function



Public Function OpenTRE(strFile As String) As Long
'****************************************
'Opens a specified TRE Archive
'
'Syntax:
'strFile: The path to the TRE Archive to open
'
'Note : This will clear all previous items in this
'TREObject and reset it to the new TRE Archive

Dim UnknownLong As Long
Dim statusstring As String
statusstring = "OpenTRE->"

StatusDescription = statusstring & "Reading Header"
DoEvents

Clear

On Error GoTo Report

Dim f
f = FreeFile

'-----------------------------
DebugEntry statusstring & "Opening " & strFile & ", " & CStr(f)
'-----------------------------

Open strFile For Binary Access Read As f
'-----------------------------
DebugEntry statusstring & "Loading Header of " & strFile & ", " & CStr(f)
'-----------------------------

Get f, , TREHeader.strID
'-----------------------------
DebugEntry statusstring & "Header ID =" & TREHeader.strID
'-----------------------------
If TREHeader.strID <> "EERT5000" Then
Close f
OpenTRE = 5
Error_Report (5)
Exit Function
End If
Get f, , TREHeader.Item_Num
Get f, , TREHeader.Tail_Start
Get f, , TREHeader.Com_Method_Tail_Info
Get f, , TREHeader.Com_Size_Tail_Info
Get f, , TREHeader.Com_Method_Tail_Filenames
Get f, , TREHeader.Com_Size_Tail_Filenames
Get f, , TREHeader.Original_Size_Tail_Filenames
'---------------------
DebugEntry statusstring & "Header variables : " & _
CStr(TREHeader.Item_Num) & "," & _
CStr(TREHeader.Tail_Start) & "," & _
CStr(TREHeader.Com_Method_Tail_Info) & "," & _
CStr(TREHeader.Com_Size_Tail_Info) & "," & _
CStr(TREHeader.Com_Method_Tail_Filenames) & "," & _
CStr(TREHeader.Com_Size_Tail_Filenames) & "," & _
CStr(TREHeader.Original_Size_Tail_Filenames)
'---------------------


ReDim Tail_Info_Data(TREHeader.Com_Size_Tail_Info - 1)
If TREHeader.Com_Method_Tail_Filenames = 1 Or TREHeader.Com_Method_Tail_Info = 1 Then
OpenTRE = 6
Error_Report (6)
Close f
Exit Function
End If
If TREHeader.Com_Method_Tail_Filenames Then
ReDim Tail_Filenames_Data(TREHeader.Com_Size_Tail_Filenames - 1)
Else
ReDim Tail_Filenames_Data(TREHeader.Original_Size_Tail_Filenames - 1) ' ????????????? TRUE?
End If

StatusDescription = statusstring & "Reading Taildata"
DoEvents

'---------------------
DebugEntry statusstring & "Reading tail data at : " & CStr(TREHeader.Tail_Start)
'---------------------

Seek f, TREHeader.Tail_Start + 1
Get f, , Tail_Info_Data
Get f, , Tail_Filenames_Data
Close f

'---------------------
DebugEntry statusstring & "Tails read (in bytes) : " & CStr(UBound(Tail_Info_Data)) & ", " & CStr(UBound(Tail_Filenames_Data))
'---------------------

'---------------------
DebugEntry statusstring & "Decompression if necessary"
'---------------------

Dim res
If TREHeader.Com_Method_Tail_Info Then
res = DecompressData(Tail_Info_Data, 24 * TREHeader.Item_Num)
'---------------------
DebugEntry statusstring & "Decompression Result: " & CStr(res)
'---------------------

If res < 0 Then
Error_Report (12)
OpenTRE = 12
Exit Function
End If
End If

If TREHeader.Com_Method_Tail_Filenames Then
res = DecompressData(Tail_Filenames_Data, TREHeader.Original_Size_Tail_Filenames)
If res < 0 Then
Error_Report (12)
OpenTRE = 12
Exit Function
End If
End If

StatusDescription = statusstring & "Creating Temporary Tailfiles"
DoEvents


Dim t1, t2 As String
t1 = App.path & "\t1.tmp"
t2 = App.path & "\t2.tmp"

'---------------------
DebugEntry statusstring & "Creating temporary tailfiles : " & vbCrLf & t1 & vbCrLf & t2
'---------------------

On Error Resume Next
Kill t1
Kill t2
On Error GoTo 0
Dim f1, f2
f1 = FreeFile
Open t1 For Binary Access Write As f1
f2 = FreeFile
Open t2 For Binary Access Write As f2
Put f1, , Tail_Info_Data
Put f2, , Tail_Filenames_Data
Close f1, f2

'---------------------
DebugEntry statusstring & "Temporary tailfiles created"
'---------------------

StatusDescription = statusstring & "Reading Tail information"
DoEvents

'---------------------
DebugEntry statusstring & "Opening Temporary Tails"
'---------------------

Open t1 For Binary Access Read As f1
Open t2 For Binary Access Read As f2

ReDim TREItemList(TREHeader.Item_Num - 1)
ReDim OffsetList(TREHeader.Item_Num - 1)

Dim c, ctr
Dim TString As String
Dim TByte As Byte

'---------------------
DebugEntry statusstring & "Reading tails"
'---------------------

For c = 0 To TREHeader.Item_Num - 1
If TREHeader.Item_Num > 1 Then Status = CDbl(c) / CDbl(TREHeader.Item_Num - 1)
DoEvents

Get f1, , TREItemList(c).Item_Unknown
Get f1, , TREItemList(c).Item_OriginalSize
Get f1, , TREItemList(c).Item_Offset
Get f1, , TREItemList(c).Item_CompressionMethod
Get f1, , TREItemList(c).Item_Size
Get f1, , TREItemList(c).Item_FilenamePosInTail
Seek f2, TREItemList(c).Item_FilenamePosInTail + 1
      TString = "": ctr = 0
      While ctr < 255
              Get f2, , TByte
              If TByte = 0 Then
              ctr = 255
              Else
               TString = TString & Chr(TByte)
               ctr = ctr + 1
               If ctr = 255 Then
               Error_Report (7)
               OpenTRE = 7
               Close f1: Close f2
               Clear
               Exit Function
               End If
               
              End If
            Wend
TREItemList(c).Item_Name = TString
Next c

Close f1
Close f2

Kill t1
Kill t2
'---------------------
DebugEntry statusstring & "Temporary tails read, closed and destroyed."
'---------------------


' this is practically all we need
' if we just create an extract function
Item_Num = TREHeader.Item_Num
Filename = strFile
Error_Report (0)
OpenTRE = 0
CurFormat = 1
Exit Function

Report:
Error_Report (4)


End Function

Public Sub Clear()
'****************************************
'Clear the TRE Object
'
'Note : This will clear all previous items in this
'TREObject. It will be reset to a default state
Dim statusstring As String
statusstring = "Clear->"
StatusDescription = statusstring & "Clearing TRE"
DoEvents

'------------------------
DebugEntry StatusDescription
'------------------------

Class_Initialize
Dim t1, t2 As String
t1 = App.path & "\t1.tmp"
t2 = App.path & "\t2.tmp"
On Error Resume Next
Kill t1
Kill t2
On Error GoTo 0
Erase TREItemList

End Sub

Public Function Create(strFilename As String, strList As String, CompressRes As Byte)
'****************************************
'Create a new TRE Archive
'
'Syntax:
'strFilename: The path to the TRE Archive to create
'strList : A string containing a list of space-delimited filenames to inlude in the archive
'   Note to list : the first entry needs to be the parent folder of all the
'                  items following in the list
'                  Example : "c:\folder file1.fil file2.fil file3.fil"
'
'Note : This will clear all previous items in this
'TREObject and reset it to the new TRE Archive
Dim AccumulationSize As Long
Dim filelist() As String
Dim Spa As String
Dim count, c, pos As Long
Dim leng As Long
Dim statusstring As String

'Class_Initialize

Clear

statusstring = "Create->"
StatusDescription = statusstring & "Creating list"
DoEvents

'------------------------
DebugEntry statusstring & "Creating NEW : " & strFilename
'------------------------
'------------------------
DebugEntry statusstring & "Sorting list"
'------------------------


leng = Len(strList)
If leng > 0 Then
c = 1: count = 0: Spa = " "
While c < leng
pos = 0
pos = InStr(c, strList, Spa, 1)
If pos Then
ReDim Preserve filelist(count)
filelist(count) = Mid(strList, c, pos - c)
c = pos + 1
count = count + 1
Else
If c <> leng Then
ReDim Preserve filelist(count)
filelist(count) = Mid(strList, c, leng)
c = leng
End If
End If
Wend
If count = 0 Then
count = count + 1
ReDim filelist(count)
filelist(count) = strList

End If

'okay got all
'now create the correct paths
If count > 1 Then

For c = 1 To count
filelist(c) = filelist(0) & filelist(c)
Next c
End If

Dim UnknownLong As Long
UnknownLong = 559568717

If count > 0 Then Item_Num = count - 1  '0 based

'------------------------
DebugEntry statusstring & "Assigning buffers"
'------------------------

'assign buffers
Dim TempBuf() As Byte
ReDim TREItemList(Item_Num)
ReDim OffsetList(Item_Num)
ReDim TempBuf(TREHeaderSize - 1)

'create TREItemlist
Dim f, f2
f2 = FreeFile
Open strFilename For Binary Access Write As f2
Put f2, , TempBuf 'save the space reserved for the header in the new file

f = FreeFile

StatusDescription = statusstring & "Processing files"
'------------------------
DebugEntry StatusDescription
'------------------------

For c = 0 To count - 1
Status = CDbl(c) / CDbl(count)
DoEvents
TREItemList(c).Item_Name = filelist(c + 1)
TREItemList(c).Item_OriginalSize = FileLen(filelist(c + 1))
If TREItemList(c).Item_OriginalSize > 0 Then
ReDim TempBuf(TREItemList(c).Item_OriginalSize - 1)
Open TREItemList(c).Item_Name For Binary Access Read As f
Get f, , TempBuf
Close f
'compress it
If CompressRes Then 'if compression is chosen then
TREItemList(c).Item_CompressionMethod = 2 'Zlib NORMAL
StatusDescription = statusstring & "Compressing " & TREItemList(c).Item_Name
'------------------------
DebugEntry StatusDescription
'------------------------
DoEvents
TREItemList(c).Item_Size = CompressData(TempBuf)
Else
StatusDescription = statusstring & "No compression of " & TREItemList(c).Item_Name
'------------------------
DebugEntry StatusDescription
'------------------------
TREItemList(c).Item_CompressionMethod = 0 'No compression
End If



' save it
StatusDescription = statusstring & "Saving " & TREItemList(c).Item_Name
'------------------------
DebugEntry StatusDescription
'------------------------
DoEvents
Put f2, , TempBuf
End If

TREItemList(c).Item_Offset = TREHeaderSize + AccumulationSize
OffsetList(c).Index = c
OffsetList(c).Offset = TREItemList(c).Item_Offset
If CompressRes Then 'if compression is chosen then
AccumulationSize = AccumulationSize + TREItemList(c).Item_Size
Else
AccumulationSize = AccumulationSize + TREItemList(c).Item_OriginalSize
End If
Next c

StatusDescription = statusstring & "Creating header and tail info"
'------------------------
DebugEntry StatusDescription
'------------------------
DoEvents
'create header
TREHeader.Item_Num = count
TREHeader.strID = "EERT5000"
TREHeader.Tail_Start = TREHeaderSize + AccumulationSize
'create null-terminated stringlist
leng = 0
For c = 0 To count - 1
leng = leng + Len(TREItemList(c).Item_Name)
Next c
leng = leng + count
ReDim Tail_Filenames_Data(leng - 1)


StatusDescription = statusstring & "Creating null-list"
'------------------------
DebugEntry StatusDescription
'------------------------

DoEvents
pos = 0: Dim tstr As String
For c = 0 To count - 1
Status = CDbl(c) / CDbl(count)
DoEvents

TREItemList(c).Item_FilenamePosInTail = pos
For leng = 0 To Len(TREItemList(c).Item_Name) - 1
tstr = Mid(TREItemList(c).Item_Name, leng + 1, 1)
Tail_Filenames_Data(pos) = CByte(Asc(tstr))
pos = pos + 1
Next leng
Tail_Filenames_Data(pos) = 0
pos = pos + 1
Next c
'done creating the nulllist

StatusDescription = statusstring & "Compressing tail"
'------------------------
DebugEntry StatusDescription
'------------------------

'compress it now
TREHeader.Original_Size_Tail_Filenames = pos
TREHeader.Com_Size_Tail_Filenames = CompressData(Tail_Filenames_Data)

'almost there
'dirty way to do it but we do it:
f = FreeFile
On Error Resume Next
Kill App.path & "\temp"
On Error GoTo 0
Open App.path & "\temp" For Binary Access Write As f
For c = 0 To count - 1
Put f, , UnknownLong
Put f, , TREItemList(c).Item_OriginalSize
Put f, , TREItemList(c).Item_Offset
Put f, , TREItemList(c).Item_CompressionMethod
Put f, , TREItemList(c).Item_Size
Put f, , TREItemList(c).Item_FilenamePosInTail
Next c
Close f
leng = 24 * count
ReDim Tail_Info_Data(leng - 1)
Open App.path & "\temp" For Binary Access Read As f
Get f, , Tail_Info_Data
Close f
Kill App.path & "\temp"
'that was dirty eh? anyway we continue
TREHeader.Com_Size_Tail_Info = CompressData(Tail_Info_Data)
TREHeader.Com_Method_Tail_Filenames = 2
TREHeader.Com_Method_Tail_Info = 2

Filename = strFilename
'right! now we are done with the header/tail business and can just create the thing
'so save the stuff

StatusDescription = statusstring & "Saving Tails"
'------------------------
DebugEntry StatusDescription
'------------------------

Put f2, , Tail_Info_Data
Put f2, , Tail_Filenames_Data

' save the header

StatusDescription = statusstring & "Saving Tails"
'------------------------
DebugEntry StatusDescription
'------------------------

Seek f2, 1
Put f2, , TREHeader.strID
Put f2, , TREHeader.Item_Num
Put f2, , TREHeader.Tail_Start
Put f2, , TREHeader.Com_Method_Tail_Info
Put f2, , TREHeader.Com_Size_Tail_Info
Put f2, , TREHeader.Com_Method_Tail_Filenames
Put f2, , TREHeader.Com_Size_Tail_Filenames
Put f2, , TREHeader.Original_Size_Tail_Filenames
Close f2
Erase TempBuf
'header written

'done!
Status = 1
StatusDescription = "Ok"
Error_Report (0)
Else
Error_Report (2)
End If




End Function

'****************************************
'****************************************
' PRIVATE FUNCTIONS
'****************************************
'****************************************
' COMMENTS SCARCE
'****************************************
'****************************************


Private Function CompressData(TheData() As Byte) As Long
'****************************************
'Compresses data given using ZLIB.DLL
'Alters TheData() to contain compressed data

OriginalSize = UBound(TheData) + 1

'Allocate memory for byte array
Dim BufferSize As Long
Dim TempBuffer() As Byte
Dim result

BufferSize = UBound(TheData) + 1
BufferSize = BufferSize + (BufferSize * 0.01) + 12
ReDim TempBuffer(BufferSize)

'Compress byte array (data)
result = compress(TempBuffer(0), BufferSize, TheData(0), UBound(TheData) + 1)

'Truncate to compressed size
ReDim Preserve TheData(BufferSize - 1)
CopyMemory TheData(0), TempBuffer(0), BufferSize

'Cleanup
Erase TempBuffer

'Set properties if no error occurred
If result = 0 Then CompressedSize = UBound(TheData) + 1

'Return error code (if any)
CompressData = CompressedSize
'---------------------
DebugEntry "CompressData>" & "Compression Result: " & CStr(result)
'---------------------

End Function

Private Function DecompressData(TheData() As Byte, OrigSize As Long) As Long
'****************************************
'DeCompresses data given using ZLIB.DLL
'Alters TheData() to contain decompressed data


'Allocate memory for buffers
Dim BufferSize As Long
Dim TempBuffer() As Byte

BufferSize = OrigSize
BufferSize = BufferSize + (BufferSize * 0.01) + 12
ReDim TempBuffer(BufferSize)

'Decompress data
result = uncompress(TempBuffer(0), BufferSize, TheData(0), UBound(TheData) + 1)

'Truncate buffer to compressed size
ReDim Preserve TheData(BufferSize - 1)
CopyMemory TheData(0), TempBuffer(0), BufferSize

'Reset properties
If result = 0 Then
CompressedSize = 0
OriginalSize = 0
End If

'Return error code (if any)
DecompressData = result
'---------------------
DebugEntry "DecompressData>" & "Decompression Result: " & CStr(result)
'---------------------

End Function

Private Function DebugEntry(strEntry As String)
Dim f, g
If strDebugLog <> "" Then

On Error Resume Next
f = FreeFile
g = FileLen(strDebugLog)
Dim s As Long
s = 256000

If g > s Then Kill strDebugLog

Open strDebugLog For Append As f
'Seek f, g + 1
Print #f, "[x] " & ErrorDescription & _
" - " & strEntry
Close f
End If



End Function


Private Function ReArrangeTREList()
Dim TempRanks() As Long
Dim AccumSize As Long
Dim TBuf() As Byte
Dim NoOfRanks As Long
Dim statusstring As String

statusstring = "ReArrangeTREList>"

StatusDescription = statusstring & "Start"

'---------------------
DebugEntry statusstring & "Start"
'---------------------
NoOfRanks = Item_Num - 1
ReDim OffsetList(NoOfRanks)
'ReDim TempRanks(NoOfRanks)



Dim Depth1, Depth2, Rank As Long
Depth1 = 0

StatusDescription = statusstring & "Sorting old list"
'---------------------
DebugEntry statusstring & "Sorting Offsetlist"
'---------------------

' sort the old list
While Depth1 < Item_Num
Status = CDbl(Depth1) / CDbl(Item_Num)
Rank = NoOfRanks
For Depth2 = 0 To Item_Num - 1
If Depth1 <> Depth2 Then
If TREItemList(Depth1).Item_Offset < TREItemList(Depth2).Item_Offset Then
Rank = Rank - 1
End If
End If
Next Depth2
OffsetList(Rank).Index = Depth1
OffsetList(Rank).Offset = TREItemList(Depth1).Item_Offset
Depth1 = Depth1 + 1
Wend

StatusDescription = statusstring & "Processing possible changes in offsets"
'---------------------
DebugEntry statusstring & "Processing possible changes in the list"
'---------------------

'Check for replacements
' find start
Depth1 = 0
While Depth1 < Item_Num
If Item_Num > 1 Then Status = CDbl(Depth1) / CDbl(Item_Num)
If TREItemList(Depth1).Item_ReplaceTarget Then
Depth2 = 0

While OffsetList(Depth2).Index <> Depth1 And Depth2 < Item_Num
Depth2 = Depth2 + 1
Wend
Depth1 = Item_Num

End If
Depth1 = Depth1 + 1
Wend
'first accumulation of size change
If TREItemList(OffsetList(Depth2).Index).Item_CompressionMethod = 0 Then
AccumSize = AccumSize + (FileLen(TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath) - TREItemList(OffsetList(Depth2).Index).Item_OriginalSize)
Else
Dim f4
f4 = FreeFile
ReDim TBuf(FileLen(TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath) - 1)
Open TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath For Binary Access Read As f4
Get f4, , TBuf
Close f4
Dim newsize As Long
newsize = CompressData(TBuf)
ReDim TBuf(0)
AccumSize = AccumSize + (newsize - TREItemList(OffsetList(Depth2).Index).Item_Size)
End If

'TREItemList(OffsetList(Depth2).Index).Item_Size = FileLen(TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath)

'go alter all
Depth2 = Depth2 + 1
While Depth2 < Item_Num
Status = CDbl(Depth2) / CDbl(Item_Num)
If TREItemList(OffsetList(Depth2).Index).Item_ReplaceTarget Then
OffsetList(Depth2).Offset = OffsetList(Depth2).Offset + AccumSize
'TREItemList(OffsetList(Depth2).Index).Item_Offset = OffsetList(Depth2).Offset
If TREItemList(OffsetList(Depth2).Index).Item_CompressionMethod = 0 Then
AccumSize = AccumSize + (FileLen(TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath) - TREItemList(Depth1).Item_OriginalSize)
Else
'Dim f4
f4 = FreeFile
ReDim TBuf(FileLen(TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath) - 1)
Open TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath For Binary Access Read As f4
Get f4, , TBuf
Close f4
'Dim newsize As Long
newsize = CompressData(TBuf)
ReDim TBuf(0)
AccumSize = AccumSize + (newsize - TREItemList(OffsetList(Depth2).Index).Item_Size)
End If 'TREItemList(OffsetList(Depth2).Index).Item_Size = FileLen(TREItemList(OffsetList(Depth2).Index).Item_ReplacerPath)
Else
OffsetList(Depth2).Offset = OffsetList(Depth2).Offset + AccumSize
'TREItemList(OffsetList(Depth2).Index).Item_Offset = OffsetList(Depth2).Offset
End If
Depth2 = Depth2 + 1
Wend

'---------------------
DebugEntry statusstring & "Processing Completed"
DebugEntry statusstring & "Estimated Sizechange (in bytes): " & CStr(AccumSize)
'---------------------

StatusDescription = statusstring & "Process completed"

'right offset list rearranged

End Function

Private Function ReplaceCurrentTargets(DestFilename As String)

Dim statusstring As String
statusstring = "ReplaceCurrentTargets>"

'---------------------
DebugEntry statusstring & "Started"
'---------------------


If DestFilename <> "" Then
ReArrangeTREList
SaveRepTRE DestFilename
Else
If ReplaceOld = 0 Then
Error_Report (12)
ReplaceCurrentTargets = 12

'---------------------
DebugEntry statusstring & ErrorDescription
'---------------------

Else
ReArrangeTREList
SaveRepTRE Filename
End If


End If

End Function

Private Function SaveRepTRE(strPath As String)
Dim TB() As Byte
Dim ff
Dim strPath1 As String
Dim BasePath As String
Dim newsize As Long
Dim statusstring As String
statusstring = "SaveRepTRE>"

'---------------------
DebugEntry statusstring & "Started"
'---------------------

Set ff = CreateObject("Scripting.FileSystemObject")

ReDim TB(35)
strPath1 = strPath
If strPath = Filename Then

If ReplaceOld = 0 Then
Error_Report (12)
SaveRepTRE = 12
Exit Function
Else
BasePath = ff.GetParentFolderName(strPath)
strPath1 = BasePath & "\temp.tre"
End If


On Error Resume Next
Kill strPath1
On Error GoTo 0
End If

Dim f, f2, f3
f = FreeFile
StatusDescription = statusstring & "Processing files"
'---------------------
DebugEntry statusstring & "Processing files"
'---------------------

Open strPath1 For Binary Access Write As f
f2 = FreeFile
Open Filename For Binary Access Read As f2
Put f, , TB
Dim c
For c = 0 To Item_Num - 1
If Item_Num > 0 Then Status = CDbl(c) / CDbl(Item_Num)
StatusDescription = statusstring & "Processing : " & CStr(c) & "/" & CStr(Item_Num)
DoEvents
If TREItemList(OffsetList(c).Index).Item_ReplaceTarget Then
f3 = FreeFile
Open TREItemList(OffsetList(c).Index).Item_ReplacerPath For Binary Access Read As f3
ReDim TB(LOF(f3) - 1)
'change variable
newsize = LOF(f3)
Get f3, , TB
Close f3
'needs compression? do it
If TREItemList(OffsetList(c).Index).Item_CompressionMethod = 2 Then
TREItemList(OffsetList(c).Index).Item_OriginalSize = newsize
newsize = CompressData(TB)
End If
TREItemList(OffsetList(c).Index).Item_Size = newsize
Put f, , TB
Else
Seek f2, TREItemList(OffsetList(c).Index).Item_Offset + 1
ReDim TB(TREItemList(OffsetList(c).Index).Item_OriginalSize - 1)
Get f2, , TB
Put f, , TB
End If
'change variable
TREItemList(OffsetList(c).Index).Item_Offset = OffsetList(c).Offset
Next c
Close f2

'ok, all resources saved
' fill in some variables

'---------------------
DebugEntry statusstring & "Creating null-list"
'---------------------

StatusDescription = statusstring & "Creating null-list"
DoEvents

'create null-terminated stringlist
Dim leng, pos As Long
leng = 0

For c = 0 To Item_Num - 1
If Item_Num > 0 Then Status = CDbl(c) / CDbl(Item_Num)
DoEvents



If TREItemList(c).Item_ReplaceTarget And ReplaceNames > 0 Then
leng = leng + Len(TREItemList(c).Item_ReplacerPath)
Else
leng = leng + Len(TREItemList(c).Item_Name)
End If
Next c
leng = leng + Item_Num
ReDim Tail_Filenames_Data(leng - 1)
DoEvents
'create the nulllist
'ReDim Tail_Filenames_Data(0)

StatusDescription = statusstring & "Creating null-list"
DoEvents

pos = 0: Dim tstr As String
For c = 0 To Item_Num - 1
Status = CDbl(c) / CDbl(Item_Num)
DoEvents
TREItemList(c).Item_FilenamePosInTail = pos

If TREItemList(c).Item_ReplaceTarget And ReplaceNames > 0 Then
For leng = 0 To Len(TREItemList(c).Item_ReplacerPath) - 1
tstr = Mid(TREItemList(c).Item_ReplacerPath, leng + 1, 1)
Tail_Filenames_Data(pos) = CByte(Asc(tstr))
pos = pos + 1
Next leng
Else
For leng = 0 To Len(TREItemList(c).Item_Name) - 1
tstr = Mid(TREItemList(c).Item_Name, leng + 1, 1)
Tail_Filenames_Data(pos) = CByte(Asc(tstr))
pos = pos + 1
Next leng
End If
Tail_Filenames_Data(pos) = 0
pos = pos + 1
Next c
'done creating the nulllist

'---------------------
DebugEntry statusstring & "Creating Tails"
'---------------------

StatusDescription = statusstring & "Creating tails"
DoEvents


TREHeader.Tail_Start = Seek(f) - 1
'compress it now
TREHeader.Original_Size_Tail_Filenames = pos
If TREHeader.Com_Method_Tail_Filenames = 2 Then
TREHeader.Com_Size_Tail_Filenames = CompressData(Tail_Filenames_Data)
Else
TREHeader.Com_Size_Tail_Filenames = 0
End If

'almost there
'dirty way to do it but we do it:

Dim UnknownLong As Long
UnknownLong = 559568717
Dim f4
f4 = FreeFile
On Error Resume Next
Kill App.path & "\temp"
On Error GoTo 0
Open App.path & "\temp" For Binary Access Write As f4
For c = 0 To Item_Num - 1
Put f4, , TREItemList(c).Item_Unknown
Put f4, , TREItemList(c).Item_OriginalSize
Put f4, , TREItemList(c).Item_Offset
Put f4, , TREItemList(c).Item_CompressionMethod
Put f4, , TREItemList(c).Item_Size
Put f4, , TREItemList(c).Item_FilenamePosInTail
Next c
Close f4
leng = 24 * Item_Num
ReDim Tail_Info_Data(leng - 1)
Open App.path & "\temp" For Binary Access Read As f4
Get f4, , Tail_Info_Data
Close f4
Kill App.path & "\temp"

'---------------------
DebugEntry statusstring & "Writing header and tails"
'---------------------

StatusDescription = statusstring & "Writing header and tails"
DoEvents

'that was dirty eh? anyway we continue
'TREHeader.Original_Size_Tail_Filenames = leng
TREHeader.Com_Size_Tail_Info = CompressData(Tail_Info_Data)
TREHeader.Com_Method_Tail_Filenames = 2
TREHeader.Com_Method_Tail_Info = 2
Put f, , Tail_Info_Data
Put f, , Tail_Filenames_Data
Seek f, 1
Put f, , TREHeader.strID
Put f, , TREHeader.Item_Num
Put f, , TREHeader.Tail_Start
Put f, , TREHeader.Com_Method_Tail_Info
Put f, , TREHeader.Com_Size_Tail_Info
Put f, , TREHeader.Com_Method_Tail_Filenames
Put f, , TREHeader.Com_Size_Tail_Filenames
Put f, , TREHeader.Original_Size_Tail_Filenames
Close f
If ReplaceOld Then
'kill the old and rename the new file
Kill Filename
Name strPath1 As Filename
End If

'---------------------
DebugEntry statusstring & "Done"
'---------------------

StatusDescription = statusstring & "Done"
DoEvents

End Function

'Private Function ObsoleteMakePath(ExistingDir, NewDir) As String
'
'Dim Base, Ext, Parent, NDir, EDir, drive, FN, Counter
'Dim Parent2 As String
'Dim E, a, intI, int3
'Dim FiO2
'Set FiO2 = CreateObject("Scripting.FileSystemObject")
'
'
'NDir = NewDir
'EDir = ExistingDir
'
'drive = FiO2.GetDriveName(NDir)
'
'If drive <> "" Then
'NDir = Mid(NDir, 3, Len(NDir) - 2)
'End If
'
'Parent = FiO2.GetParentFolderName(NDir)
'FN = FiO2.GetFileName(NDir)
'Base = FiO2.GetBaseName(NDir)
'Ext = FiO2.GetExtensionName(NDir)
'Parent2 = Parent
'Parent2 = FiO2.BuildPath(Parent2, FN)
'
'
''check for occureces of "../" or "..\"
'Counter = 0
'a = Len(Parent2)
'For intI = 1 To a
'   If Mid$(Parent2, intI, 3) = "../" Or _
'      Mid$(Parent2, intI, 3) = "..\" Then
'       Parent2 = Mid$(Parent2, 1, intI - 1) & Mid$(Parent2, intI + 3, a - (int3 - 3)): a = Len(Parent2)
'       intI = intI + 3
'
'   End If
'
'Next intI
'
'
'
'Counter = 0
'
''Check Number of separators
'If Len(Parent) = 0 Then
' MakePath = Parent2
' Exit Function
'End If
'
'
'Counter = 0
'For intI = Len(Parent) To 1 Step -1
'   If Mid$(Parent, intI, 1) = "/" Or _
'      Mid$(Parent, intI, 1) = "\" Then Counter = Counter + 1
'Next intI
'
''Get the damn folders
'
'
'Dim Folders
'ReDim Folders(Counter)
'
'
'For intI = Counter To 1 Step -1
'Folders(intI) = FiO2.GetBaseName(Parent)
'Parent = FiO2.GetParentFolderName(Parent)
'Next intI
'Folders(0) = Parent
''Make them all
'
'For intI = 0 To Counter
'EDir = FiO2.BuildPath(EDir, Folders(intI))
'On Error Resume Next
'MkDir (EDir)
'Next intI
'On Error GoTo Handler
'
''Done
'MakePath = Parent2
'Exit Function
'Handler:
'
'End
'
'
'End Function

Private Sub Error_Report(ErrNum As Long)

ErrorState = ErrNum
Select Case ErrNum
Case 0: ErrorDescription = "Ok"
Case 1: ErrorDescription = "Illegal index"
Case 2: ErrorDescription = "No file(s) specifified to add to new TRE"
Case 3: ErrorDescription = "Could not save TRE file"
Case 4: ErrorDescription = "Error opening TRE file"
Case 5: ErrorDescription = "Not a valid TRE file"
Case 6: ErrorDescription = "Decompression method 1 not supported"
Case 7: ErrorDescription = "Attempt to read filename string longer than 255 bytes"
Case 8: ErrorDescription = "Illegal or no file(s) specified for extraction"
Case 9: ErrorDescription = "Error while decompressing item in TRE"
Case 10: ErrorDescription = "Illegal or no file(s) targeted for replacement"
Case 11: ErrorDescription = "Item name passed to Replace function does not exist"
Case 12: ErrorDescription = "Decompression of tail Failed"

End Select
DebugEntry "[!] " & ErrorDescription & " " & CStr(ErrorState)

End Sub

Private Sub Class_Initialize()
Item_Num = 0
Filename = ""
TREHeaderSize = 36
Error_Report (0)
Erase Tail_Info_Data
Erase Tail_Filenames_Data

End Sub
